Global( "TextName", {} )
Global( "TextDamage", {} )
Global( "TextPos", {} )
Global( "PPerDamage", {} )
Global( "PUnit", {} )
Global( "PMain", {} )
Global( "PM", nil )
Global( "Slp", nil )
Global( "PTick", {} )
Global( "DUnit", {} )
Global( "DUnitf", {} )
Global( "DUnits", {} )
Global( "Menu", {} )
Global( "Container", {} )
Global( "ConCon", 0 )
--
Global( "WTime", 300)
Global( "Lastparams", nil )
Global( "LastFght", 1 )
Global( "LastSpell", 1 )
Global( "FSpells", {})
Global( "StForm", {
	userMods.ToWString("<header fontsize='14' shadow = '1'><r name='Name'/></header>"),
	userMods.ToWString("<header fontsize='14' shadow = '1'><r name='Min'/>:<r name='Sec'/></header>")
	--userMods.ToWString("<header fontsize='14' shadow = '1'><r name='Min'/>:<r name='Sec'/> (<r name='DPS'/>)</header>")
	
	
})

--==--
function SetMyParents()
local Par = stateMainForm:GetChildUnchecked("ContextBag",false)
if Par then
	Par:AddChild(mainForm)
end
Par = stateMainForm:GetChildUnchecked("ContextTooltip",false)
if Par then
	Par:AddChild(PMain[3])
else
	Par = stateMainForm:GetChildUnchecked("Tooltip",true)
	if Par then Par:GetParent():AddChild(PMain[3]) end
end
--common.LogInfo(common.GetAddonName(),"Tooltip Parent:", Par:GetName())
end

function GetLT (t0)
local tme = mission.GetLocalTimeHMS()
if t0 and type (t0)=="number" then
	return (36e4*tme.h + 6e3*tme.m + 1e2*tme.s +tme.ms) - t0
else
	return 36e4*tme.h + 6e3*tme.m + 1e2*tme.s +tme.ms
end
end

function SetHisMode (name)
if name == "Fight_Damage_Done" then
	Battle.cnf.fighis = true
	Battle.cnf.curtable = TABLE_UNITS
elseif name == "Damage_Done" then
	Battle.cnf.fighis = false
	Battle.cnf.curtable = TABLE_UNITS
elseif name == "Fight_Damage_Taken" then
	Battle.cnf.fighis = true
	Battle.cnf.curtable = TABLE_ENEMIES
elseif name == "Damage_Taken" then
	Battle.cnf.fighis = false
	Battle.cnf.curtable = TABLE_ENEMIES
elseif name == "Fight_Healing_Done"then
	Battle.cnf.fighis = true
	Battle.cnf.curtable = TABLE_HEALERS
elseif name == "Healing_Done" then
	Battle.cnf.fighis = false
	Battle.cnf.curtable = TABLE_HEALERS
elseif name == "Fight_Healing_Taken" then
	Battle.cnf.fighis = true
	Battle.cnf.curtable = TABLE_HEAL
else
	Battle.cnf.fighis = false
	Battle.cnf.curtable = TABLE_HEAL
end
Container[2]:GetParent():GetChildUnchecked("PanelHeader", false):GetChildUnchecked("TextHeader", false):SetVal("Mode", GetTextLocalized(GetHisMode()))
end

function GetHisMode ()
if Battle.cnf.curtable == TABLE_UNITS then
	return Battle.cnf.fighis and "Fight_Damage_Done" or "Damage_Done"
elseif Battle.cnf.curtable == TABLE_ENEMIES then
	return Battle.cnf.fighis and "Fight_Damage_Taken" or "Damage_Taken"
elseif Battle.cnf.curtable == TABLE_HEALERS then
	return Battle.cnf.fighis and "Fight_Healing_Done" or "Healing_Done"
else--if Battle.cnf.curtable == TABLE_ENEMIES then
	return Battle.cnf.fighis and "Fight_Healing_Taken" or "Healing_Taken"
end
end

function SetVisMode (name)
if name == "Damage" then Battle.cnf.curvis = V_DAMAGE
elseif name == "Heal" then Battle.cnf.curvis = V_HEAL
elseif name == "DpS" then Battle.cnf.curvis = V_DPS
else --name == "HpS" then
	Battle.cnf.curvis = V_HPS
end
PMain[1]:SetVal("Name", GetTextLocalized(GetVisMode()))
end

function GetVisMode ()
if Battle.cnf.curvis == V_DAMAGE then return "Damage"
elseif Battle.cnf.curvis == V_HEAL then return "Heal"
elseif Battle.cnf.curvis == V_DPS then return "DpS"
else--if Battle.cnf.curvis == V_HPS then
	return "HpS"
end
end

function GetTextLocalized (strText)
return Lc[Lang][strText] and userMods.ToWString(Lc[Lang][strText]) or userMods.ToWString(strText)
end

function SetAddonLoc (loc)
--Based on AO game Localization detection by SLA. Version 2011-02-10.
if loc == "auto" then
	for _,mb in cartographer.GetMapBlocks() do
		for l,t in {rus="\203\232\227\224", eng="Holy Land", ger="Heiliges Land", fra="Terre Sacr\233e", br="Terra Sagrada", jpn="\131\74\131\106\131\65"} do
			if userMods.FromWString( cartographer.GetMapBlockInfo(mb).name ) == t then
				return SetAddonLoc(l)
			end
		end
	end
else
	for v,t in Lc do
		if t.LShort and t.LShort == loc then return v end
	end
end
return 1
end

function CheckVer ()	--by SLA
if mount.SetSkin then return 2001
elseif group.IsLeader then return 2000
elseif social.GetFriendInfo then return 1104
elseif not unit.IsDead then return 1103
end
return 1102
end

function Config (csave)
if csave then
	userMods.SetGlobalConfigSection("Battle"..srevision, Battle.cnf)
	--userMods.SetGlobalConfigSection("Battle"..srevision, {})
else
	local btl = {}
	btl = userMods.GetGlobalConfigSection("Battle"..srevision)
	if btl then 
	for v, t in pairs(btl) do
		if type(Battle.cnf[v]) ~= "nil" then Battle.cnf[v] = t end
	end
	end
end
end

function GoSleep (gsleep)
Battle.cnf.freeze = gsleep
PM:Show(not gsleep)
local pos
if gsleep then
	mainForm:AddChild(Slp)
	--stateMainForm:GetChildUnchecked("Plates",false):GetChildUnchecked("Avatar",false):AddChild(Slp)
	--stateMainForm:GetChildUnchecked("Plates",false):AddChild(Slp)
	mainForm:GetChildUnchecked("PanelGraph", false):Show(false)
	mainForm:GetChildUnchecked("PanelDetail", false):Show(false)
DnDReg(5)
	pos = Slp:GetPlacementPlain()
	pos.alignY, pos.alignX = WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW
else
	pos = Slp:GetPlacementPlain()
	for i=1,4 do DnDReg(i) end
	DnDUnReg(5)
	if not PM:GetChildUnchecked("BtnFreeze", false) then
		PM:AddChild(Slp)
	end
	mainForm:GetChildUnchecked("PanelGraph", false):Show(Battle.cnf.grph)
	pos.highposX, pos.posY, pos.alignY, pos.alignX = 45, 3, WIDGET_ALIGN_LOW, WIDGET_ALIGN_HIGH
end
PMain[3]:SetFade(gsleep and 0 or (Battle.bin and 1 or 0))
Slp:SetPlacementPlain(pos)
Config (true)
end

function RefrGraph (zero)
local db = (Battle.cnf.curvis == V_DAMAGE or Battle.cnf.curvis == V_DPS) and CurFight.db[TABLE_UNITS] or CurFight.db[TABLE_HEALERS]
local mn,av,mx,pos,tme = 1e9,0,0,mainForm:GetChildUnchecked("PanelGraph", false)
if zero then
	while db.DPS[1] and db.DPS[1] == 0 do table.remove(db.DPS,1) end
end
if not db.DPS[1] then return end
if db.DPS[1]>0 and pos:IsVisible() then
	tme = table.getn(db.DPS)
	tme = tme > 0 and (tme > MaxTicks and MaxTicks or tme)*TRefresh or 1
	for v,t in db.DPS do
		if v > MaxTicks then break end
		if mx < t then mx = t end
		if mn > t then mn = t end
		av = av + t
	end
	pos = pos:GetChildUnchecked("TextGraph1", false)
	pos:SetVal("GMax", Format45d(mx/TRefresh))
	pos:SetVal("GMin", Format45d(mn/TRefresh))
	pos:SetVal("GTotal", Format45d(av))
	av = av/tme
	---tme = mn + 100
	pos:SetVal("GAvg", Format45d(av))
	pos = PTick[MaxTicks+1]:GetPlacementPlain()
	pos.sizeY = TRefresh*90*(av-mn)/(mx-mn)
	PTick[MaxTicks+1]:SetPlacementPlain(pos)
	for i=1,MaxTicks do
		pos = PTick[i]:GetPlacementPlain()
		tme = pos.sizeY
		pos.sizeY = db.DPS[i] and (90*(db.DPS[i]-mn))/(mx-mn) or 0
		if tme ~= pos.sizeY then
			PTick[i]:SetPlacementPlain(pos)
		end
	end
end
end

function RefrVisData ()
local tbl, pos, pg = {}, 0, PM:GetChildUnchecked("PanelGroup", false)
--local tbl = GetCurGroupDPS(TABLE_UNITS)
local ftbl, mypos, tbl, mx = GetCurDPS(TABLE_UNITS), 1
local db = (Battle.cnf.curvis == V_DAMAGE or Battle.cnf.curvis == V_DPS) and CurFight.db[TABLE_UNITS].DPS or CurFight.db[TABLE_HEALERS].DPS

tbl = GetCurGroupDPS(TABLE_UNITS)

PMain[2]:SetVal("Damage", Format45d(ftbl[1]))
PMain[2]:SetVal("DPS", Format45d(ftbl[2]))


if CurFight.ftime > 0 then
	for i,t in tbl do
		if string.find(Battle.avasn, t[1]) then
			mypos = t[5]
			break
		end
	end

	PMain[3]:SetVal("Value", Format45d(mypos))
	--PMain[1]:SetVal("DPS", Format45d(mypos))
end

PMain[1]:SetVal("Min", Format02d(ftbl[3]))
PMain[1]:SetVal("Sec", Format02d(ftbl[4]))

if pg:IsVisible() --[[and Battle.dmge]] then
	--tbl = GetCurGroupDPS(TABLE_UNITS)
	if ConCon > table.getn(tbl) then
		ConCon = 0
		Container[1]:RemoveItems()
	end
	mx = tbl[1] and tbl[1][2] or 0
	for i,t in tbl do
		TextName[i]:SetVal("Pos", Format02d(i))
		TextName[i]:SetVal("Name", t[3])
		TextDamage[i]:SetVal("Damage", Format45d(t[2]))
		TextDamage[i]:SetVal("DPS", Format45d(t[5]))
		pos = PPerDamage[i]:GetPlacementPlain()
		pos.sizeX = mx>0 and 280 * t[2]/mx or 0
		PPerDamage[i]:SetPlacementPlain(pos)
		PPerDamage[i]:GetParent():SetBackgroundColor(t[4])
		PPerDamage[i]:SetBackgroundColor(t[4])
		if ConCon < i then
			Container[1]:PushBack(PUnit[i])
			ConCon  = i
		end
	end
	pos = pg:GetPlacementPlain()
	tbl = table.getn(tbl)
	tbl = tbl < MaxUnits and tbl or MaxUnits
	tbl = tbl > MinUnits and tbl or MinUnits
	pos.sizeY = 21 * tbl
	pg:SetPlacementPlain(pos)
end
end

function CreateWidgets()
--[[
Panels
[1] - avatars PanelUnit
[2]..[7] - Group PanelUnit

Containers
[1] - Group
[2] - Fights Names
[3] - Fights Units
[4] - Unit Spells
]]
local pos
local wdt = {}
PM = mainForm:GetChildUnchecked("PanelMain", false)
Slp = PM:GetChildUnchecked("BtnFreeze", false)
---PanelUnit
PUnit[1] = PM:GetChildUnchecked("PanelUnit", false)
PPerDamage[1] = PUnit[1]:GetChildUnchecked("PanelPers", false)
TextDamage[1] = PUnit[1]:GetChildUnchecked("TextDPS", false)
TextName[1] = PUnit[1]:GetChildUnchecked("TextName", false)
mainForm:GetChildUnchecked("PanelDetail", false):AddChild(PUnit[1])
--TextPos[1] = PUnit[1]:GetChildUnchecked("TextPers", false)

--PanelGroup
wdt[1] = PM:GetChildUnchecked("PanelGroup", false)
wdt[2] = PUnit[1]:GetWidgetDesc()
for i = 2, 24 do
	PUnit[i] = mainForm:CreateWidgetByDesc(wdt[2])
	mainForm:GetChildUnchecked("PanelDetail", false):AddChild(PUnit[i])
	PPerDamage[i] = PUnit[i]:GetChildUnchecked("PanelPers", false)
	TextDamage[i] = PUnit[i]:GetChildUnchecked("TextDPS", false)
	TextName[i] = PUnit[i]:GetChildUnchecked("TextName", false)
	--TextPos[i] = PUnit[i]:GetChildUnchecked("TextPers", false)
end
Container[1] = wdt[1]:GetChildUnchecked("ContainerGroup", false)

--PanelMain
wdt[1] = PM:GetChildUnchecked("PanelM", false)
--Slp = wdt[1]:GetChildUnchecked("BtnFreeze", false)
--wdt[1]:SetBackgroundColor(MainColor)
PMain[1] = wdt[1]:GetChildUnchecked("TextBN", false)
PMain[2] = PM:GetChildUnchecked("TextBDPS", false)

--selfDPS
--PMain[3] = mainForm:GetChildUnchecked("PanelDPS", false):GetChildUnchecked("TextDPS", false)
PMain[3] = mainForm:GetChildUnchecked("TextDPS", false)
PMain[3]:SetFade(0)
--PMain[3]:Show(true)
--PMain[3]:SetVal("Value", Format02d(999))

--Graph
wdt[1] = mainForm:GetChildUnchecked("PanelGraph", false)
PTick[1] = wdt[1]:GetChildUnchecked("PanelTick", false)
PTick[1]:SetBackgroundColor( { r = 0.18; g = 0.57; b = 1; a = 1 } )
pos = PTick[1]:GetPlacementPlain()
pos.sizeX = math.floor(330/MaxTicks)
PTick[1]:SetPlacementPlain(pos)
wdt[2] = PTick[1]:GetWidgetDesc()
for i=2, MaxTicks do
	PTick[i] = mainForm:CreateWidgetByDesc(wdt[2])
	wdt[1]:AddChild(PTick[i])
	pos.highPosX = pos.highPosX + pos.sizeX
	PTick[i]:SetPlacementPlain(pos)
	--PTick[i]:SetBackgroundColor( { r = 0.5; g = 0.1; b = 0.7; a = 1.0} )
	PTick[i]:SetBackgroundColor( { r = 0.18; g = 0.57; b = 1; a = 1} )
end
PTick[MaxTicks+1] = wdt[1]:GetChildUnchecked("PanelAvg", false)
--PTick[MaxTicks1]:SetBackgroundColor( { r = 1.0; g = 1.0; b = 0.0; a = 1.0 } )
PTick[MaxTicks+1]:SetPriority(425)

wdt[3] = wdt[1]:GetChildUnchecked("TextGraph2", false)
pos = wdt[3]:GetPlacementPlain()
wdt[3]:SetVal("sc",Format02d(MaxTicks*TRefresh))
wdt[2] = wdt[3]:GetWidgetDesc()
for i=1, 2 do
	wdt[3] = mainForm:CreateWidgetByDesc(wdt[2])
	wdt[3]:SetVal("sc",Format02d(0.6667*MaxTicks*TRefresh/i))
	wdt[1]:AddChild(wdt[3])
	--pos = wdt[3]:GetPlacementPlain()
	--pos.posX = 5 + i*110
	pos.posX = pos.posX + 110
	wdt[3]:SetPlacementPlain(pos)
	
end

--Containers
wdt[1] = mainForm:GetChildUnchecked("PanelDetail", false)
Container[2] = wdt[1]:GetChildUnchecked("Container", false)
pos = Container[2]:GetPlacementPlain()
--pos.posY, pos.sizeY, pos.posX, pos.sizeX, pos.alignX = 40, 250, 0, 360 , WIDGET_ALIGN_LOW
pos.posY, pos.sizeY, pos.posX, pos.sizeX = 40, 250, 0, 360
Container[2]:SetPlacementPlain(pos)

wdt[2] = Container[2]:GetWidgetDesc()

Container[3] = mainForm:CreateWidgetByDesc(wdt[2])
wdt[1]:AddChild(Container[3])
pos = Container[2]:GetPlacementPlain()
--pos.posY, pos.sizeY, pos.posX, pos.sizeX, pos.alignX = 60, 490, 360, 360 , WIDGET_ALIGN_LOW
pos.posY, pos.sizeY, pos.posX, pos.sizeX = 60, 490, 360, 360
Container[3]:SetPlacementPlain(pos)

Container[4] = mainForm:CreateWidgetByDesc(wdt[2])
wdt[1]:AddChild(Container[4])
pos = Container[2]:GetPlacementPlain()
--pos.posY, pos.sizeY, pos.posX, pos.sizeX, pos.alignX = 310, 190, 0, 360 , WIDGET_ALIGN_LOW
pos.posY, pos.sizeY, pos.posX, pos.sizeX = 310, 190, 0, 360
Container[4]:SetPlacementPlain(pos)

--DUnit
DUnit[1] = wdt[1]:GetChildUnchecked("PanelDBUnit", false)
DUnits[1] = wdt[1]:GetChildUnchecked("PanelSpell", false)
DUnits[1]:SetName("PnlS_1")
wdt[1]:GetChildUnchecked("TextAddon", false):Show(true)


--History menu
Menu[1] = mainForm:GetChildUnchecked("PanelSelect", false)
mainForm:GetChildUnchecked("PanelDetail", false):AddChild(Menu[1])
wdt[3] = {
	"Fight_Damage_Done",
	"Fight_Damage_Taken",
	"Fight_Healing_Done",
	"Fight_Healing_Taken",
	"Damage_Done",
	"Damage_Taken",
	"Healing_Done",
	"Healing_Taken",
	"Lne",
	"Reset"
}
pos = Menu[1]:GetPlacementPlain()
pos.sizeY = table.getn(wdt[3]) * 20 + 30
Menu[1]:SetPlacementPlain(pos)
wdt[1] = Menu[1]:GetChildUnchecked("BtnSlct", false)
wdt[1]:SetName(wdt[3][1])
wdt[1]:SetVal("Value",GetTextLocalized(wdt[3][1]))
wdt[2] = wdt[1]:GetWidgetDesc()
pos = wdt[1]:GetPlacementPlain()
for i=2, table.getn(wdt[3]) do
	wdt[1] = mainForm:CreateWidgetByDesc(wdt[2])
	Menu[1]:AddChild(wdt[1])
	pos.posY = i * 20 - 5
	wdt[1]:SetPlacementPlain(pos)
	wdt[1]:SetName(wdt[3][i])
	wdt[1]:SetVal("Value",GetTextLocalized(wdt[3][i]))
end

--Curren fight menu
wdt[3] = wdt[1]:GetParent():GetWidgetDesc()
Menu[2] = mainForm:CreateWidgetByDesc(wdt[3])
Menu[2]:SetName("CFMenu")
PM:AddChild(Menu[2])
wdt[3] = {
	"Damage",
	"Heal",
	"DpS",
	"HpS",
	"Lne",
	"Reset"
}
pos = Menu[2]:GetPlacementPlain()
pos.sizeY = table.getn(wdt[3]) * 20 + 30
pos.sizeX = 200
Menu[2]:SetPlacementPlain(pos)
wdt[1] = Menu[2]:GetChildUnchecked("BtnSlct", false)
wdt[1]:SetName(wdt[3][1])
wdt[1]:SetVal("Value",GetTextLocalized(wdt[3][1]))
pos = wdt[1]:GetPlacementPlain()
for i=2, table.getn(wdt[3]) do
	wdt[1] = mainForm:CreateWidgetByDesc(wdt[2])
	Menu[2]:AddChild(wdt[1])
	pos.posY = i * 20 - 5
	wdt[1]:SetPlacementPlain(pos)
	wdt[1]:SetName(wdt[3][i])
	wdt[1]:SetVal("Value",GetTextLocalized(wdt[3][i]))
end
end

function SetColors ()
if not MainColor or type(MainColor.r) ~= "number" or type(MainColor.g) ~= "number" or type(MainColor.b) ~= "number" then
	MainColor = GetColor(unit.GetClass(avatar.GetId()).className)
end
MainColor.a = 1
local wdt, vlet = PM:GetChildUnchecked("PanelM", false), common.CreateValuedText()
wdt:SetBackgroundColor(MainColor)
wdt:GetChildUnchecked("BtnUpDn", false):SetBackgroundColor(MainColor)
Slp:SetBackgroundColor(MainColor)
wdt = mainForm:GetChildUnchecked("PanelDetail", false)
wdt:GetChildUnchecked("PanelHeader", false):SetBackgroundColor(MainColor)
wdt:GetChildUnchecked("TextAddon", false):SetBackgroundColor(MainColor)
wdt:GetChildUnchecked("TextF", false):SetBackgroundColor(MainColor)
wdt:GetChildUnchecked("TextD", false):SetBackgroundColor(MainColor)

--[[vlet = PM:GetChildUnchecked("TextBDPS", false)
--local tmp = " color='0xff"..string.format('%02x%02x%02x',255*MainColor.g,255*MainColor.b,255*MainColor.r).."'"
--common.LogInfo("","tmp ", tmp)
vlet:SetFormat(userMods.ToWString("<html fontsize='14' outline = '1' color='0xff"..string.format('%02x%02x%02x',255*MainColor.g,255*MainColor.b,255*MainColor.r).."'><r name='Damage'/> (<r name='DPS'/>)</html>"))]]
end

function PlaceSDetail (snum)
if LastSpell == snum then return end
if not FSpells then return end
--mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("PanelTimes", false):Show(false)
local pnlSD = mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("PanelSDetail", false)
--pnlSD:Show(true)
LastSpell = snum
pnlSD = pnlSD:GetNamedChildren()
local tbl = FSpells[snum]
if not tbl or (not tbl[1]) then return end
for v,t in pnlSD do
	if t:GetName() == "TextSAdd" then
		t:SetVal("Name",tbl[2])
	elseif t:GetName() == "TextSAdd1" then
		t:SetVal("Max",Format45d(tbl[6]))
		t:SetVal("Mid",Format45d(tbl[7]))
		t:SetVal("Min",Format45d(tbl[8]))
		t:SetVal("Crit",Format02d(tbl[9]))
		t:SetVal("Glans",Format02d(tbl[10]))
	elseif t:GetName() == "TextSAdd2" then
		t:SetVal("Lost",Format45d(tbl[17]))
		t:SetVal("Perlost",Format02d(tbl[18]))
		t:SetVal("Resist",Format45d(tbl[15]))
		t:SetVal("Absorb",Format45d(tbl[16]))
	elseif t:GetName() == "TextSAdd3" then
		t:Show(Battle.cnf.curtable < TABLE_HEALERS)
		if Battle.cnf.curtable < TABLE_HEALERS then
			t:SetVal("ShB",Format45d(tbl[13]))
			t:SetVal("Parry",Format45d(tbl[14]))
			t:SetVal("Miss",Format02d(tbl[11]))
			t:SetVal("Dodge",Format02d(tbl[12]))
		end
	end
end
end

function PlaceSpells (unum)
Container[4]:RemoveItems()
local wdt, wdt2, pos = DUnits[1]:GetWidgetDesc()
if Battle.cnf.fighis then
	Container[2]:GetParent():GetChildUnchecked("TextD", false):SetVal("Figr", L_units[Fights[LastFght].db[Battle.cnf.curtable].tUnits[unum].myid].uName)
	FSpells = GetUnitSpells(GetRequest("ONE"),unum)
else
	FSpells = GetUnitSpells(GetRequest("ALL"),unum)
	Container[2]:GetParent():GetChildUnchecked("TextD", false):SetVal("Figr", L_units[unum].uName)
end
if not FSpells then return end
for v, t in FSpells do
	if not DUnits[v] then
		DUnits[v] = mainForm:CreateWidgetByDesc(wdt)
		DUnits[v]:SetName("PnlS_"..v)
	end
	wdt2 = DUnits[v]:GetNamedChildren()
	for u,p in wdt2 do
		if p:GetName() == "TextSName" then
			p:SetVal("Name", t[2])
		elseif p:GetName() == "TextSDPS" then
			p:SetVal("Damage", Format45d(t[1]))
			p:SetVal("Cnt", Format02d(t[5]))
		elseif p:GetName() == "TextSPers" then
			p:SetVal("Pers", Format02d(t[4]))
		elseif p:GetName() == "PanelPers" then
			p:SetBackgroundColor(t[3])
			pos = p:GetPlacementPlain()
			pos.sizeX = 3.3 * t[4]
			p:SetPlacementPlain(pos)
		end
	end
Container[4]:PushBack(DUnits[v])
end
LastSpell = 0
PlaceSDetail (1)
end

function PlaceFighters (fnum)
local wdt, pos, tbl, dam = DUnit[1]:GetWidgetDesc()
Container[3]:RemoveItems()

if Battle.cnf.fighis then
	Container[3]:GetParent():GetChildUnchecked("TextF", false):SetVal("Pos", Format02d(1+table.getn(Fights)-fnum))
	Container[3]:GetParent():GetChildUnchecked("TextF", false):SetVal("Fig", Fights[fnum].fName)
	tbl = GetGroupDPS(Battle.cnf.curtable,fnum)
else
	tbl = GetAllUnits(Battle.cnf.curtable)
	Container[3]:GetParent():GetChildUnchecked("TextF", false):ClearValues()
end

if not tbl or (not tbl[1]) then
	if not Battle.cnf.fighis then Container[2]:RemoveItems() end
	Container[4]:RemoveItems()
	return
end
dam = tbl[1] and tbl[1][2]>0 and tbl[1][2] or 1
--common.LogInfo("","dam ", tostring(dam))
for v, t in tbl do
	if not DUnitf[v] then
		DUnitf[v] = mainForm:CreateWidgetByDesc(wdt)
	end
	for u,p in DUnitf[v]:GetNamedChildren() do
		if p:GetName() == "TextDBName" then
			p:SetVal("Pos", Format02d(v))
			p:SetVal("Name", t[1])
		elseif p:GetName() == "TextDBDPS" then
			p:SetVal("Damage", Format45d(t[2]))
			p:SetVal("DPS", Format45d(t[5]))
		elseif p:GetName() == "TextDBTime" then
			if not Battle.cnf.fighis then
				p:SetVal("Sec", Format02d(t[7]))
			else
				p:ClearValues()
			end
			p:SetVal("Min", Format02d(t[6]))
		elseif p:GetName() == "PanelPers" then
			p:SetBackgroundColor(t[4])
			pos = p:GetPlacementPlain()
			pos.sizeX = 330 * t[2]/dam
			--common.LogInfo("","pos ", tostring(pos.sizeX)," - ", tostring(t[2]))
			p:SetPlacementPlain(pos)
		elseif string.find(p:GetName(),"Btn") then
		if Battle.cnf.fighis then
			p:SetName("BtnD_"..tostring(v))
		else
			p:SetName("BtnD_"..tostring(t[3]))
		end
	end
end
Container[3]:PushBack(DUnitf[v])
end

if Battle.cnf.fighis then
	LastFght = fnum
	PlaceTimes(LastFght)
	PlaceSpells (1)
else
PlaceFights (tbl[1][3])
PlaceSpells (tbl[1][3])
end
end

function PlaceTimes (fnum)
--common.LogInfo(common.GetAddonName(),"PlaceTimes", Format45d(fnum))
local wdt = mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("PanelTimes", false)
local tbl = Fights[fnum].ftime_unit
wdt = wdt:GetNamedChildren()
	for v,t in wdt do
		if t:GetName() == "TextTime1" then
			t:SetVal("Thh", Format02d(tbl[1]))
			t:SetVal("Tmm", Format02d(tbl[2]))
			t:SetVal("Tss", Format02d(tbl[3]))
			t:SetVal("Name", L_units[tbl[7]].uName)
			t:SetVal("Spell", tbl[9])
		elseif t:GetName() == "TextTime2" then
			t:SetVal("Thh", Format02d(tbl[4]))
			t:SetVal("Tmm", Format02d(tbl[5]))
			t:SetVal("Tss", Format02d(tbl[6]))
			t:SetVal("Name", L_units[tbl[8]].uName)
			t:SetVal("Spell", tbl[10])
		end
	end
end

function PlaceFights (uin)
--common.LogInfo(common.GetAddonName(),"uin - ", Format02d(uin))
local wdt, wdt2,mn,sc, tbl = DUnit[1]:GetWidgetDesc()
Container[2]:RemoveItems()
if Battle.cnf.fighis then
	tbl = GetFights (Battle.cnf.curtable)
else
	tbl = GetAllUnFights(Battle.cnf.curtable, uin)
end
if not tbl or (not tbl[1]) then
	if Battle.cnf.fighis then Container[3]:RemoveItems() end
	return
end
for v,t in tbl do
	if not DUnit[v] then
		DUnit[v] = mainForm:CreateWidgetByDesc(wdt)
	end
	wdt2 = DUnit[v]:GetNamedChildren()
	for u,p in wdt2 do
		if p:GetName() == "TextDBName" then
			p:SetVal("Pos", Format02d(table.getn(tbl)-v+1))
			p:SetVal("Name", t[1])
		elseif p:GetName() == "TextDBDPS" then
			p:SetVal("Damage", Format45d(t[2]))
			p:SetVal("DPS", Format45d(t[4]))
		elseif p:GetName() == "TextDBTime" then
			mn,sc = GetMinSec(t[3])
			p:SetVal("Min", Format02d(mn))
			p:SetVal("Sec", Format02d(sc))
			elseif string.find(p:GetName(),"Btn") then
			if Battle.cnf.fighis then
				p:SetName("BtnDU_"..tostring(v))
			else
				p:SetName("BtnFD_"..tostring(v))
			end
		end
	end
Container[2]:PushBack(DUnit[v])
end
if Battle.cnf.fighis then PlaceFighters (uin) end
PlaceTimes(1)
end

function DataInit ()
VRefresh = (VRefresh < 1) and 1 or VRefresh
MaxUnits = (MaxUnits < 3) and 3 or ((MaxUnits > 20) and 20 or MaxUnits)
MinUnits = (MinUnits < 3) and 3 or ((MinUnits > MaxUnits) and MaxUnits or MinUnits)
MaxHistory = (MaxHistory < 5) and 5 or MaxHistory
MaxTicks = MaxTicks < 10 and 10 or (MaxTicks > 150 and 150 or MaxTicks)
TRefresh = TRefresh < 1 and 1 or (TRefresh > 1e3 and 1e3 or TRefresh)
DnDStep = DnDStep < 1 and 1 or (DnDStep > 50 and 50 or DnDStep)


--WTime = WTime < 1e2 and 1e2 or (WTime > 5e3 and 5e3 or WTime)
WTime = (unit.GetClass(avatar.GetId()).className == "NECROMANCER") and 1000 or 500
--common.LogInfo("","WTime = ", tostring(WTime))

Config()
Battle.avaid = avatar.GetId()
Battle.avasn = userMods.FromWString(object.GetName(Battle.avaid))
PM:GetChildUnchecked("PanelGroup", false):Show(Battle.cnf.gropened)
PM:GetChildUnchecked("PanelM", false):GetChildUnchecked("BtnUpDn", false):SetVariant(Battle.cnf.gropened and 1 or 0)
GoSleep (Battle.cnf.freeze)
Resetdata()
SetHisMode (GetHisMode())
SetVisMode (GetVisMode())
Battle.inbuild = true
end

function SaveFightincfg()
userMods.SetGlobalConfigSection("CurFight", CurFight.db[TABLE_UNITS])
--userMods.SetGlobalConfigSection("CurFight", Fights[table.getn(Fights)].tUnits)
end

function Init()
Reg(EVRe)
if avatar.IsExist () then EVRe.EVENT_AVATAR_CREATED() end
end

Init()
